#include "mainwindow.h"
#include <math.h>
#include <time.h>


int i_TempoAnim=500;
int iC1=0,iC2=0,iD1=0,iD2=0,iU1=0,iU2=0,iN1=0,iN2=0,iCnt=0;

int iU1o=0,iU2o=0,iD1o=0,iD2o=0,iC1o=0,iC2o=0;
int iMinAdd=1,iMaxAdd=998,iMinTot=21,iMaxTot=999,iSeme=-0;
bool blRipDec=true,blRipCen=true;
char sNome[128]="Prova";
int iUni=0,iDec=20,iCen=60,
		iColUni=0,iColDec=1,iColCen=3;
int iColUniId[8],iColDecId[8],iColCenId[8];

char sNomiImmagini[16][8]={"gr.png","r.png","v.png","b.png","m.png","g.png","c.png","mr.png",
                          "grs.png","rs.png","vs.png","bs.png","ms.png","gs.png","cs.png"};

char sNomiColori[8][8]={
			"black",
			"red",
			"green",
			"blue",
			"magenta",
			"yellow",
			"cyan",
			"brown"
};

int rand10()
{
  return (int) (10.0*rand()/(RAND_MAX+1.0));
}



PictureItem::PictureItem(QSizeF size, const QPixmap& pixmap, QObject* parent) :
    QObject(parent), QGraphicsPixmapItem(pixmap)
{
    m_size = size;
    setCacheMode(DeviceCoordinateCache);
}

PictureItem::~PictureItem()
{
}

QRectF PictureItem::boundingRect() const
{
return QRectF(0, 0, 700, 580);
}

qreal PictureItem::rotationAngleY() const
{
    return m_rotationAngleY;
}

void PictureItem::setRotationAngleY(qreal angle)
{
    if (m_rotationAngleY != angle) {
        m_rotationAngleY = angle;
        QPointF c = boundingRect().center();
        QTransform t;
        t.translate(c.x(), c.y());
        t.rotate(m_rotationAngleY, Qt::YAxis);
        t.translate(-c.x(), -c.y());
        setTransform(t);
    }
}

void PictureItem::setFade(int f)
{
    m_fade = f;

    if ((m_fade == 255 || m_fade == 0) && m_originalPicForFade.isNull()) {
        m_originalPicForFade = pixmap();
    }

    QPixmap pic;
    if (m_originalPicForFade.isNull())
        pic = pixmap();
    else
        pic = m_originalPicForFade;

    QPixmap transparent(pic.size());
    transparent.fill(Qt::transparent);
    QPainter p(&transparent);
    p.setCompositionMode(QPainter::CompositionMode_Source);
    p.drawPixmap(0, 0, pic);
    p.setCompositionMode(QPainter::CompositionMode_DestinationIn);
    p.fillRect(transparent.rect(), QColor(0, 0, 0, m_fade));
    p.end();
    pic = transparent;
    transparent = 0;

    setPixmap(pic);
}

int PictureItem::fade() const
{
    return m_fade;
}

void PictureItem::animatePosition(const QPointF& start, const QPointF& end)
{
    // Start animate this class
    QPropertyAnimation* anim = new QPropertyAnimation(this, "pos");

    // 2 second duration animation
    anim->setDuration(i_TempoAnim);
    // position to start animation
    anim->setStartValue(start);
    // end position of animation
    anim->setEndValue(end);
    // easing curve
//    anim->setEasingCurve(QEasingCurve::InCirc);
//    anim->setEasingCurve(QEasingCurve::OutBounce);

    // Listen animation finished signal
    QObject::connect(anim, SIGNAL(finished()), this, SLOT(animationFinished()));

    // Start animation and delete QPropertyAnimation class on the end
    anim->start(QAbstractAnimation::DeleteWhenStopped);
}

void PictureItem::animateAngle(int startAngle, int endAngle)
{
    // Start animate this class
    QPropertyAnimation* anim = new QPropertyAnimation(this, "rotationAngleY");

    // 2 second duration animation
    anim->setDuration(i_TempoAnim);
    // angle to start animation
    anim->setStartValue(startAngle);
    // end angle of animation
    anim->setEndValue(endAngle);
    // easing curve
    anim->setEasingCurve(QEasingCurve::InOutBack);

    // Listen animation finished signal
    QObject::connect(anim, SIGNAL(finished()), this, SLOT(animationFinished()));

    // Start animation and delete QPropertyAnimation class on the end
    anim->start(QAbstractAnimation::DeleteWhenStopped);
}

void PictureItem::animatePosAndAngle(const QPointF& start, const QPointF& end,
                                     int startAngle, int endAngle)
{
    // Create animation group
    // Animations in the group are executed in same time
    QParallelAnimationGroup *group = new QParallelAnimationGroup;

    // Create rotation animation
    QPropertyAnimation* anim1 = new QPropertyAnimation(this, "rotationAngleY");
    anim1->setDuration(i_TempoAnim);
    anim1->setStartValue(startAngle);
    anim1->setEndValue(endAngle);
    anim1->setEasingCurve(QEasingCurve::InOutBack);

    // Create position animation
    QPropertyAnimation* anim2 = new QPropertyAnimation(this, "pos");
    anim2->setDuration(i_TempoAnim);
    anim2->setStartValue(start);
    anim2->setEndValue(end);
    anim2->setEasingCurve(QEasingCurve::InOutElastic);

    // Add animations into the group
    group->addAnimation(anim1);
    group->addAnimation(anim2);

    // Execute group
    group->start(QAbstractAnimation::DeleteWhenStopped);
}


void PictureItem::animateFadeIn()
{
    // Start animate this class
    QPropertyAnimation* anim = new QPropertyAnimation(this, "fade");
    anim->setDuration(i_TempoAnim);
    anim->setStartValue(255);
    anim->setEndValue(0);
    anim->setEasingCurve(QEasingCurve::Linear);

    QObject::connect(anim, SIGNAL(finished()), this, SLOT(animationFinished()));

    anim->start(QAbstractAnimation::DeleteWhenStopped);
}

void PictureItem::animateFadeOut()
{
    // Start animate this class
    QPropertyAnimation* anim = new QPropertyAnimation(this, "fade");
    anim->setDuration(i_TempoAnim);
    anim->setStartValue(0);
    anim->setEndValue(255);
    anim->setEasingCurve(QEasingCurve::Linear);

    QObject::connect(anim, SIGNAL(finished()), this, SLOT(animationFinished()));

    anim->start(QAbstractAnimation::DeleteWhenStopped);
}

void PictureItem::animateScale(qreal start, qreal end)
{
    // Start animate this class
    QPropertyAnimation* anim = new QPropertyAnimation(this, "scale");
    anim->setDuration(i_TempoAnim);
    anim->setStartValue(start);
    anim->setEndValue(end);
    anim->setEasingCurve(QEasingCurve::InOutBack);

    QObject::connect(anim, SIGNAL(finished()), this, SLOT(animationFinished()));

    anim->start(QAbstractAnimation::DeleteWhenStopped);
}

void PictureItem::animationFinished()
{
    // This slot is called when animation ends
    if ((m_fade == 255 || m_fade == 0) && m_originalPicForFade.isNull()) {
        m_originalPicForFade = pixmap();
    }

    QPixmap pic;
    if (m_originalPicForFade.isNull())
        pic = pixmap();
    else
        pic = m_originalPicForFade;

}




MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    int i,j;
    int scrH,scrW;
    char sBuf[128]="";
    QDesktopWidget dw;
    scrH=dw.height();
    scrW=dw.width();
    fnNumbers = new QFont("Courier", 30, QFont::Bold,false);
    fnHelp = new QFont("Helvetica", 14, QFont::Bold,false);
    fnLittle = new QFont("Helvetica",8,false,false);

    setGeometry((scrW-800)/2,(scrH-600)/2,800,600);

    setFixedSize(QSize(800,600));
    setWindowTitle("Esercizi con le addizioni");

		QMessageBox msgBox;
    msgBox.setText("Programma per l'addestramento all'addizione.");
    msgBox.setIcon(QMessageBox::Information);
		msgBox.setInformativeText(QString::fromUtf8("Questo programma è stato scritto usando le librerie Qt prodotte da Trolltech/Nokia e distribuite con licenza lgpl.\n\nIl programma viene distribuito con licenza gpl.\n\nSe il codice sorgente non è allegato basta chiederlo all'autore all'indirizzo p.delise@gmail.com.\n\nLe eventuali modifiche apportate da altri al codice sorgente dovranno essere ridistribuite con la stessa licenza.\n\n Copyright P.Delise (2011) - Trieste"));
		msgBox.setStandardButtons(QMessageBox::Ok);
		msgBox.setDefaultButton(QMessageBox::Ok);
		msgBox.exec();

    FILE *f=fopen("somme.ini","r");
		if (f){
      char str[128];
      int r,b;
      r=fscanf(f,"%s %d\n",str,&iMinAdd);
      r=fscanf(f,"%s %d\n",str,&iMaxAdd);
      r=fscanf(f,"%s %d\n",str,&iMinTot);
      r=fscanf(f,"%s %d\n",str,&iMaxTot);
      r=fscanf(f,"%s %d\n",str,&iSeme);
      r=fscanf(f,"%s %d\n",str,&b);
      blRipDec=(b==1)?true:false;
    	r=fscanf(f,"%s %d\n",str,&b);
			blRipCen=(b==1)?true:false;
      r=fscanf(f,"%s %d %d\n",str,&iUni,&iColUni);
    	r=fscanf(f,"%s %d %d\n",str,&iDec,&iColDec);
    	r=fscanf(f,"%s %d %d\n",str,&iCen,&iColCen);
    	r=fscanf(f,"%s %d \n",str,&i_TempoAnim);
	    fclose(f);
      if(r==0){}; //per imbrogliare il compilatore
printf("\n%d\n",iColCen);
    } 
    // Create QGraphicsScene and QGraphicsView
    m_scene = new QGraphicsScene(this);
    m_scene->setSceneRect(0,0,640,640);
    m_view = new QGraphicsView(m_scene,this);
    m_view->setCacheMode(QGraphicsView::CacheBackground);
//    m_view->setViewportUpdateMode(QGraphicsView::BoundingRectViewportUpdate);
    m_view->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    m_view->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
//    m_view->setContentsMargins(0,0,this->width()-50,800);

    // Create PictureItem for the animation
    QPixmap pmP[16];
    for (i=0;i<16;i++)pmP[i].load(sNomiImmagini[i]);
    QPixmap pb("w.png");

    for(i=0;i<160;i++) m_item[i]=new PictureItem(pmP[i/10].size(),pmP[i/10],this);
//    i_TempoAnim=500;
    for (i=0;i<8;i++){
      for(j=0;j<10;j++){
				m_item[i*20+j]=new PictureItem(pmP[i].size(),pmP[i],this);
				m_item[i*20+j+10]=new PictureItem(pmP[i+8].size(),pmP[i+8],this);
      }
    }
		for(i=0;i<160;i++){
       m_scene->addItem(m_item[i]);
       m_item[i]->setVisible(false);
    }
    m_itemb = new PictureItem(pb.size(),pb,this);
    m_scene->addItem(m_itemb);
    m_itemb->animatePosition(m_itemb->pos(),QPointF(590,0));
//    createMenu();

    this->setCentralWidget(m_view);
    for (i=0;i<160;i++){
       m_item[i]->animatePosition(m_item[i]->pos(),QPointF(-50-20*i,10+20*i));
    }
//    i_TempoAnim=500;     
    m_view->setAlignment(Qt::AlignLeft|Qt::AlignTop) ;


    pbSomma = new QPushButton("Nuovo\nEsercizio",this);
    pbSomma->setGeometry(680,50,100,100);
    pbSomma->adjustSize(); 
    pbSomma->setVisible(true);
    connect (pbSomma,SIGNAL(clicked()),this,SLOT(prepara()));

    pbBasta = new QPushButton("Basta",this);
    pbBasta->setGeometry(680,100,30,28);
    pbBasta->adjustSize();
    pbBasta->setVisible(true);
    connect (pbBasta,SIGNAL(clicked()),this,SLOT(fine()));
 
    pbImposta = new QPushButton("Imposta il\nsistema",this);
    pbImposta->setGeometry(680,160,100,100);
    pbImposta->adjustSize(); 
    pbImposta->setVisible(true);
    connect (pbImposta,SIGNAL(clicked()),this,SLOT(imposta()));



    gbImposta = new QGroupBox("Impostazioni",this);
    gbImposta-> setGeometry(650,10,140,580);
    gbImposta->setVisible(false);

    gbNome = new QGroupBox("Identificativo allievo",gbImposta);
    gbNome->setGeometry(10,30,120,40);
    gbNome->setFont(*fnLittle); 
    
    leNome = new QLineEdit("",gbNome);
    leNome->setGeometry(0,15,100,20);
    leNome->setFont(*fnLittle);

    gbMinAdd = new QGroupBox(QString::fromUtf8("Min addendo (≥1)"),gbImposta);
    gbMinAdd->setGeometry(10,80,120,40);
    gbMinAdd->setFont(*fnLittle); 
    
    leMinAdd = new QLineEdit("",gbMinAdd);
    leMinAdd->setGeometry(0,15,100,20);
    leMinAdd->setFont(*fnLittle);

    gbMaxAdd = new QGroupBox(QString::fromUtf8("Max addendo (≤999)"),gbImposta);
    gbMaxAdd->setGeometry(10,130,120,40);
    gbMaxAdd->setFont(*fnLittle); 
    
    leMaxAdd = new QLineEdit("",gbMaxAdd);
    leMaxAdd->setGeometry(0,15,100,20);
    leMaxAdd->setFont(*fnLittle);

    gbMinTot = new QGroupBox(QString::fromUtf8("Min totale (≥21)"),gbImposta);
    gbMinTot->setGeometry(10,180,120,40);
    gbMinTot->setFont(*fnLittle); 
    
    leMinTot = new QLineEdit("",gbMinTot);
    leMinTot->setGeometry(0,15,100,20);
    leMinTot->setFont(*fnLittle);

    gbMaxTot = new QGroupBox(QString::fromUtf8("Max totale (≤999)"),gbImposta);
    gbMaxTot->setGeometry(10,230,120,40);
    gbMaxTot->setFont(*fnLittle); 
    
    leMaxTot = new QLineEdit("",gbMaxTot);
    leMaxTot->setGeometry(0,15,100,20);
    leMaxTot->setFont(*fnLittle);

    gbRip = new QGroupBox("Riporti",gbImposta);
    gbRip->setGeometry(10,280,120,60);
    gbRip->setFont(*fnLittle); 

    cbRipDec = new QCheckBox("Sulle decine", gbRip);
    cbRipDec->setGeometry(10,15,120,20);
    cbRipDec->setFont(*fnLittle); 

    cbRipCen = new QCheckBox("Sulle centinaia", gbRip);
    cbRipCen->setGeometry(10,35,120,20);
    cbRipCen->setFont(*fnLittle); 

    gbAnim = new QGroupBox(QString::fromUtf8("Animazione (ms) "),gbImposta);
    gbAnim->setGeometry(10,430,120,40);
    gbAnim->setFont(*fnLittle); 
    
    leAnim = new QLineEdit("",gbAnim);
    leAnim->setGeometry(0,15,100,20);
    leAnim->setFont(*fnLittle);

    gbSeme = new QGroupBox(QString::fromUtf8("Seme iniziale"),gbImposta);
    gbSeme->setGeometry(10,470,120,40);
    gbSeme->setFont(*fnLittle); 
    
    leSeme = new QLineEdit("",gbSeme);
    leSeme->setGeometry(0,15,100,20);
    leSeme->setFont(*fnLittle);

    laColori = new QLabel("Colori",gbImposta);
    laColori->setGeometry(10,345,20,12);
    laColori->setFont(*fnLittle);
    laColori->adjustSize();
    bgU = new QButtonGroup(gbImposta);
		bgU->setExclusive(true);
    bgD = new QButtonGroup(gbImposta);
		bgD->setExclusive(true);
    bgC = new QButtonGroup(gbImposta);
		bgC->setExclusive(true);
    for(i=0;i<8;i++){
			laCol[i]=new QLabel(" ",gbImposta);
      laCol[i]->setGeometry(25+i*13,360,12,12);
      sprintf(sBuf,"QLabel   { background-color : %s; }",sNomiColori[i]);   
      laCol[i]->setStyleSheet(sBuf);
      rbU[i]=new QRadioButton("",gbImposta);
			rbU[i]->setGeometry(25+i*13,380,13,13);
			rbU[i]->setStyleSheet("QRadioButton::indicator { width: 13px; height: 13px; }");
      bgU->addButton(rbU[i]);
      iColUniId[i]=bgU->id(rbU[i]);
      rbD[i]=new QRadioButton("",gbImposta);
			rbD[i]->setGeometry(25+i*13,395,13,13);
			rbD[i]->setStyleSheet("QRadioButton::indicator { width: 13px; height: 13px; }");
      bgD->addButton(rbD[i]);
      iColDecId[i]=bgD->id(rbD[i]);
      rbC[i]=new QRadioButton("",gbImposta);
			rbC[i]->setGeometry(25+i*13,410,13,13);
			rbC[i]->setStyleSheet("QRadioButton::indicator { width: 13px; height: 13px; }");
      bgC->addButton(rbC[i]);
      iColCenId[i]=bgC->id(rbC[i]);
		}
    laCU = new QLabel("Un",gbImposta);
    laCU->setGeometry(10,380,13,13);
		laCU->setFont(*fnLittle);
		laCU->adjustSize(); 
    laCD = new QLabel("De",gbImposta);
    laCD->setGeometry(10,395,13,13);
		laCD->setFont(*fnLittle);
		laCD->adjustSize(); 
    laCC = new QLabel("Ce",gbImposta);
    laCC->setGeometry(10,410,13,13);
		laCC->setFont(*fnLittle);
		laCC->adjustSize(); 
    rbU[iColUni]->setChecked(true);
    rbD[iColDec]->setChecked(true);
    rbC[iColCen]->setChecked(true);
    pbAnnulla = new QPushButton("Annulla",gbImposta);
    pbAnnulla->setGeometry(20,510,30,28);
    pbAnnulla->adjustSize();
    pbAnnulla->setVisible(true);


    pbOk = new QPushButton("Ok",gbImposta);
    pbOk->setGeometry(20,540,30,28);
    pbOk->adjustSize();
    pbOk->setVisible(true);


    leRC=new QLineEdit("",this);
    leRC->setGeometry(300,30,50,60);
    leRC->setFont(*fnNumbers);
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColCen]);   
    leRC->setStyleSheet(sBuf);
    leRC->setVisible(false);
    leRD=new QLineEdit("",this);
    leRD->setGeometry(350,30,50,60);
    leRD->setFont(*fnNumbers);  
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColDec]);   
    leRD->setStyleSheet(sBuf);
    leRD->setVisible(false) ;

    laC1=new QLabel("",this);
    laC1->setGeometry(300,100,50,50);
    laC1->setFont(*fnNumbers);  
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColCen]);   
    laC1->setStyleSheet(sBuf);
    laD1=new QLabel("",this);
    laD1->setGeometry(350,100,50,50);
    laD1->setFont(*fnNumbers);
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColDec]);   
    laD1->setStyleSheet(sBuf);
    laU1=new QLabel("",this);
    laU1->setGeometry(400,100,50,50);
    laU1->setFont(*fnNumbers);  
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColUni]);   
    laU1->setStyleSheet(sBuf);

    laPiu=new QLabel("+",this);
    laPiu->setGeometry(450,100,50,50);
    laPiu->setFont(*fnNumbers);  
    laPiu->setVisible(false);


    laC2=new QLabel("",this);
    laC2->setGeometry(300,250,50,50);
    laC2->setFont(*fnNumbers);  
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColCen]);   
    laC2->setStyleSheet(sBuf);
    laD2=new QLabel("",this);
    laD2->setGeometry(350,250,50,50);
    laD2->setFont(*fnNumbers);  
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColDec]);   
    laD2->setStyleSheet(sBuf);
    laU2=new QLabel("",this);
    laU2->setGeometry(400,250,50,50);
    laU2->setFont(*fnNumbers);  
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColUni]);   
    laU2->setStyleSheet(sBuf);

    laUguale=new QLabel("=",this);
    laUguale->setGeometry(450,250,50,50);
    laUguale->setFont(*fnNumbers);  
    laUguale->setVisible(false);

    leTC=new QLineEdit("",this);
    leTC->setGeometry(300,400,50,60);
    leTC->setFont(*fnNumbers);  
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColCen]);   
    leTC->setStyleSheet(sBuf);
    leTC->setVisible(false);
    leTD=new QLineEdit("",this);
    leTD->setGeometry(350,400,50,60);
    leTD->setFont(*fnNumbers);  
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColDec]);   
    leTD->setStyleSheet(sBuf);
    leTD->setVisible(false); 
    leTU=new QLineEdit("",this);
    leTU->setGeometry(400,400,50,60);
    leTU->setFont(*fnNumbers);  
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColUni]);   
    leTU->setStyleSheet(sBuf);
    leTU->setVisible(false) ;

    laGuida=new QLabel("",this);
    laGuida->setGeometry(250,500,250,50);
    laGuida->setFont(*fnHelp);
    laGuida->setVisible(true); 


    connect(leTU, SIGNAL(textEdited(const QString &)),this, SLOT(controlloUnita(const QString &))); 
    connect(leTD, SIGNAL(textEdited(const QString &)),this, SLOT(controlloDecine(const QString &))); 
    connect(leTC, SIGNAL(textEdited(const QString &)),this, SLOT(controlloCentinaia(const QString &))); 
    connect(leRD, SIGNAL(textEdited(const QString &)),this, SLOT(controlloRiportoDecine(const QString &))); 
    connect(leRC, SIGNAL(textEdited(const QString &)),this, SLOT(controlloRiportoCentinaia(const QString &))); 

    connect (pbOk,SIGNAL(clicked()),this,SLOT(setParametri()));
    connect (pbAnnulla,SIGNAL(clicked()),this,SLOT(setAnnulla()));
   



}

MainWindow::~MainWindow()
{
}

void MainWindow::resizeEvent(QResizeEvent *)
{
/*    // Update scene rect
    m_scene->setSceneRect(m_view->rect());

    // Calculate center point for the picture
    m_center = QPointF((rect().width()-m_item->boundingRect().width())/2,
                       (rect().height()-m_item->boundingRect().height())/2 );
    // Set picture to center of the sceen
    m_item->setPos(m_center);
*/
}

void MainWindow::mousePressEvent(QMouseEvent *)
{
/*
    // Set picture to center of the sceen
    m_item->setPos(m_center);
    m_item->setFade(255);
    m_item->setScale(1.0);
*/
}

void MainWindow::coloraGrafico()
{
char sBuf[128];

    vuotaGrafico();

    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColCen]);   
    leRC->setStyleSheet(sBuf);
    leRC->setText("");
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColDec]);   
    leRD->setStyleSheet(sBuf);
    leRD->setText("");
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColCen]);   
    laC1->setStyleSheet(sBuf);
    laC1->setText("");
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColDec]);   
    laD1->setStyleSheet(sBuf);
    laD1->setText("");
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColUni]);   
    laU1->setStyleSheet(sBuf);
    laU1->setText("");
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColCen]);   
    laC2->setStyleSheet(sBuf);
    laC2->setText("");
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColDec]);   
    laD2->setStyleSheet(sBuf);
    laD2->setText("");
    sprintf(sBuf,"QLabel   { color : %s; }",sNomiColori[iColUni]);   
    laU2->setStyleSheet(sBuf);
    laU2->setText("");
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColCen]);   
    leTC->setStyleSheet(sBuf);
    leTC->setText("");
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColDec]);   
    leTD->setStyleSheet(sBuf);
    leTD->setText("");
    sprintf(sBuf,"QLineEdit   { color : %s; }",sNomiColori[iColUni]);   
    leTU->setStyleSheet(sBuf);
    leTU->setText("");

}


void MainWindow::createMenu()
{
#ifdef Q_OS_WIN32
    QMenu* menu = this->menuBar()->addMenu("Animate");
    menu->addAction("Position", this, SLOT(animatePos()));
    menu->addAction("Angle", this, SLOT(animateAngle()));
    menu->addAction("Fade in", this, SLOT(animateFadeIn()));
    menu->addAction("Fade out", this, SLOT(animateFadeOut()));
    menu->addAction("Scale", this, SLOT(animateScale()));
    menu->addAction("Pos and angle", this, SLOT(animatePosAndAngle()));

#else
    this->menuBar()->addAction("Position", this, SLOT(animatePos()));
    this->menuBar()->addAction("Angle", this, SLOT(animateAngle()));
    this->menuBar()->addAction("Fade in", this, SLOT(animateFadeIn()));
    this->menuBar()->addAction("Fade out", this, SLOT(animateFadeOut()));
    this->menuBar()->addAction("Scale", this, SLOT(animateScale()));
    this->menuBar()->addAction("Pos and angle", this, SLOT(animatePosAndAngle()));
#endif
}

void MainWindow::animatePos()
{
  int i;
    // Animate picture position
//    m_item->animatePosition(m_item->pos(),this->rect().bottomRight());

    for (i=0;i<160;i++){
       m_item[i]->animatePosition(m_item[i]->pos(),QPointF(-2000-20*i,10+20*i));
    }

      for(i=0;i<160;i+=10){
  			m_item[i]->setVisible(true);
        m_item[i]->animatePosition(m_item[i]->pos(),QPointF(100,40+20*i/10));
      }
}

void MainWindow::animateAngle()
{
/*    // Animate picture angle
    m_item->animateAngle(0,360);

*/
}

void MainWindow::animateFadeIn()
{
/*
    m_item->animateFadeIn();
*/
}

void MainWindow::animateFadeOut()
{
/*
    m_item->animateFadeOut();
*/
}

void MainWindow::animateScale()
{
/*    m_item->animateScale(1.0,2.0);
*/
}

void MainWindow::animatePosAndAngle()
{
/*
m_item->animatePosAndAngle(m_item->pos(),
                           this->rect().bottomRight(),
                           0,
                           360);
*/
}

void MainWindow::fine()
{
	exit(0);
}

void MainWindow::imposta(){

QString qsBuffer;
  laGuida->setVisible(false);
  pbSomma->setVisible(false);
  pbImposta->setVisible(false);
  pbBasta->setVisible(false);
  gbImposta->setVisible(true);
  gbImposta->setFlat(false); 



  leNome->setText(sNome);

  leNome->text().fromUtf8(sNome,strlen(sNome));
  leMinAdd->setText(qsBuffer.setNum(iMinAdd));
  leMaxAdd->setText(qsBuffer.setNum(iMaxAdd));
  leMinTot->setText(qsBuffer.setNum(iMinTot));
  leMaxTot->setText(qsBuffer.setNum(iMaxTot));
  leSeme->setText(qsBuffer.setNum(iSeme));
  leAnim->setText(qsBuffer.setNum(i_TempoAnim));

  cbRipDec->setCheckState(Qt::Unchecked);
  cbRipCen->setCheckState(Qt::Unchecked);
  if (blRipDec)cbRipDec->setCheckState(Qt::Checked);
  if (blRipCen)cbRipCen->setCheckState(Qt::Checked);
  
  bgU->button(iColUniId[iColUni])->setChecked(true);
  bgD->button(iColDecId[iColDec])->setChecked(true);
  bgC->button(iColCenId[iColCen])->setChecked(true);
  

}

void MainWindow::setAnnulla()
{
  gbImposta->setVisible(false);
  pbSomma->setVisible(true);
  pbImposta->setVisible(true);
  laGuida->setVisible(true);
	pbBasta->setVisible(true);
}

void MainWindow::setParametri()
{
int i;
  FILE *f=fopen("somme.ini","w");
  if (f==NULL){
		QMessageBox msgBox;
    msgBox.setText("Impossibile aprire il file configurazione.");
    msgBox.setIcon(QMessageBox::Critical);
 		msgBox.setInformativeText(QString::fromUtf8("Impossibile aprire il file configurazione. O non c'è spazio sul disco o non si possiedono i diritti di scrittura. Non sarà possibile modificare i colori."));
		msgBox.setStandardButtons(QMessageBox::Ok);
 		msgBox.setDefaultButton(QMessageBox::Ok);
 		msgBox.exec();
  }
  strcpy(sNome,leNome->text().toUtf8());
  iMinAdd=leMinAdd->text().toInt();
  iMaxAdd=leMaxAdd->text().toInt();
  iMinTot=leMinTot->text().toInt();
  iMaxTot=leMaxTot->text().toInt();
  iSeme=leSeme->text().toInt();
  i_TempoAnim=leAnim->text().toInt();
  blRipDec=cbRipCen->checkState()==Qt::Checked;
  blRipCen=cbRipCen->checkState()==Qt::Checked;
  if(f){
    fprintf(f,"Addendo_Minimo___= %d\n",iMinAdd);
    fprintf(f,"Addendo_Massimo__= %d\n",iMaxAdd);
    fprintf(f,"Totale_Minimo____= %d\n",iMinTot);
    fprintf(f,"Totale_Massimo___= %d\n",iMaxTot);
    fprintf(f,"Seme_random______= %d\n",iSeme);
    fprintf(f,"Riporto_Decine___= %d\n",blRipDec);
    fprintf(f,"Riporto_Centinaia= %d\n",blRipCen);
		for (i=0;i<8;i++){
	 		if(bgU->checkedId()==iColUniId[i]){
				iColUni=i;
		    iUni=20*i;
		  }
	 		if(bgD->checkedId()==iColDecId[i]){
				iColDec=i;
		    iDec=20*i;
		  }
	 		if(bgC->checkedId()==iColCenId[i]){
				iColCen=i;
		    iCen=20*i;
		  }
		}
    fprintf(f,"Colori_Unita_____= %d %d\n",iUni,iColUni);
    fprintf(f,"Colori_Decine____= %d %d\n",iDec,iColDec);
    fprintf(f,"Colori_Centinaia_= %d %d\n",iCen,iColCen);
		fprintf(f,"Tempo_Animazione_= %d\n",i_TempoAnim);
    fclose(f);
//    execl("Somme","Somme",NULL);
//    exit(1);
	}
  setAnnulla();
  vuotaGrafico();
  coloraGrafico();
}



void MainWindow::prepara()
{

QString s[]={"0","1","2","3","4","5","6","7","8","9"};
QString msg=QString::fromUtf8("Somma le unità della colonna di destra");
bool blCiclo=false;

int i;

//  i_TempoAnim=500;
  vuotaGrafico();
  if(iSeme==0) srand(time(0));
  if (iSeme>0) srand(iSeme);
  do{
    blCiclo=false;
    do{
			iC1=rand10();
			laC1->setText((iC1!=0)?s[iC1]:" ");
			iD1=rand10();
			laD1->setText((iC1!=0 || iD1!=0)?s[iD1]:" ");
			iU1=rand10();
			laU1->setText(s[iU1]);
      iN1=iC1*100+iD1*10+iU1;
      iCnt++;
      if(iCnt>10000){
        blCiclo=true;
        break;
      }
		}while(iN1<iMinAdd || iN1>iMaxAdd);
    if(!blCiclo) do{
			iU2=rand10();
			laU2->setText(s[iU2]);
			iD2=rand10();
			iC2=rand10();
     	iN2=iC2*100+iD2*10+iU2;
			laD2->setText((iC2!=0 || iD2!=0)?s[iD2]:" ");
			laC2->setText((iC2!=0)?s[iC2]:" ");
      iCnt++;
      if (iCnt>10000){
        blCiclo=true;
        break;
      }  
      
		}while(iN2<iMinAdd || iN2>iMaxAdd);
    if(blCiclo){
				QMessageBox msgBox;
        msgBox.setText("Impossibile preparare un esercizio.");
        msgBox.setIcon(QMessageBox::Critical);
 				msgBox.setInformativeText(QString::fromUtf8("Chiedi all'insegnante di controllare le impostazioni o prova a far ripartire il programma che adesso sarà terminato."));
				msgBox.setStandardButtons(QMessageBox::Ok);
 				msgBox.setDefaultButton(QMessageBox::Ok);
 				msgBox.exec();
				exit(1);
    }

    blCiclo|=(iN1+iN2)>iMaxTot || (iN1+iN2)<iMinTot;
    blCiclo|=iU1+iU2>=10 &&!blRipDec;
    blCiclo|=iD1+iD2+(iU1+iU2)/10>=10 &&!blRipCen;
  }while(blCiclo);

  leTU->setVisible(true);
  leTD->setVisible(false);
  leTC->setVisible(false);
  leRD->setVisible(false);
  leRC->setVisible(false);
  leTU->setText("");
  leTD->setText("");
  leTC->setText("");
  leRD->setText("");
  leRC->setText("");

  laPiu->setVisible(true);
  laUguale->setVisible(true);

    // Animate picture position
//    m_item->animatePosition(m_item->pos(),this->rect().bottomRight());
      for(i=0;i<iU1;i++){
  			m_item[i+iUni]->setVisible(true);
        m_item[i+iUni]->animatePosition(m_item[i+iUni]->pos(),QPointF(150,90+15*i));
      }
      for(i=0;i<iD1;i++){
  			m_item[i+iDec]->setVisible(true);
        m_item[i+iDec]->animatePosition(m_item[i+iDec]->pos(),QPointF(100,90+15*i));
      }
      for(i=0;i<iC1;i++){
  			m_item[i+iCen]->setVisible(true);
        m_item[i+iCen]->animatePosition(m_item[i+iCen]->pos(),QPointF(50,90+15*i));
      }
      for(i=0;i<iU2;i++){
  			m_item[i+iUni+10]->setVisible(true);
        m_item[i+iUni+10]->animatePosition(m_item[i+iUni+10]->pos(),QPointF(150,250+15*i));
      }
      for(i=0;i<iD2;i++){
  			m_item[i+iDec+10]->setVisible(true);
        m_item[i+iDec+10]->animatePosition(m_item[i+iDec+10]->pos(),QPointF(100,250+15*i));
      }
      for(i=0;i<iC2;i++){
  			m_item[i+iCen+10]->setVisible(true);
        m_item[i+iCen+10]->animatePosition(m_item[i+iCen+10]->pos(),QPointF(50,250+15*i));
      }
      iU1o=iU1;
      iU2o=iU2;
      iD1o=iD1;
      iD2o=iD2;
      iC1o=iC1;
      iC2o=iC2;
    laGuida->setText(msg);
    laGuida->setVisible(true);
    laGuida->adjustSize();
    leTU->setFocus();

}

void MainWindow::controlloUnita(const QString & text)
{
  int i, iU=text.toInt();

  if (text.length()==0)return;

  for(i=0;i<iU2o;i++){
		m_item[i+iUni+10]->setVisible(true);
    m_item[i+iUni+10]->animatePosition(m_item[i+iUni+10]->pos(),QPointF(150,550-15*(iU2o-i-1)));
  }
  for(i=0;i<iU1o;i++){
		m_item[i+iUni]->setVisible(true);
    m_item[i+iUni]->animatePosition(m_item[i+iUni]->pos(),QPointF(150,550-iU2o*15-15*(iU1o-i-1)));
  }

  if(iU!=(iU1o+iU2o)%10) {
    laGuida->setText(QString::fromUtf8("Conta le palline di destra; scrivi le unità"));
    laGuida->setVisible(true);
    laGuida->adjustSize();

  }else if ( iU1o+iU2o>=10 && iU==(iU1o+iU2o)%10 ){
    laGuida->setText(QString::fromUtf8("Scrivi il riporto"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
    for(i=0;i<iU1o;i++){
			m_item[i+iUni]->setVisible(true);
      m_item[i+iUni]->animatePosition(m_item[i+iUni]->pos(),QPointF(-50,550-iU2o*15-15*(iU1o-i-1)));
    } 
    for(i=0;i<10-iU1o;i++){
			m_item[i+iUni+10]->setVisible(true);
      m_item[i+iUni+10]->animatePosition(m_item[i+iUni+10]->pos(),QPointF(-50,550-15*(iU2o-i-1)));
    }
		for (i=0;i<(iU1o+iU2o)/10;i++){
 			m_item[i+iD1o+iDec]->setVisible(true);
      m_item[i+iD1o+iDec]->animatePosition(m_item[i+iD1o+iDec]->pos(),QPointF(100,70-15*(i+1)));
    }
    leRD->setVisible(true);
    leRD->setFocus();
  }else if(iU==(iU1o+iU2o)%10 && iU1o+iU2o<10){
    laGuida->setText(QString::fromUtf8("Somma le decine"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
    leTD->setVisible(true);
    leTD->setFocus();
  }

}

void MainWindow::controlloDecine(const QString & text)
{
  int i, iU=text.toInt(),iR=(iD1o+iD2o+(iU1o+iU2o)/10);
  int iY=550;
  if (text.length()==0)return;

  for(i=iD2o-1;i>=0;i--){
		m_item[i+iDec+10]->setVisible(true);
    m_item[i+iDec+10]->animatePosition(m_item[i+iDec+10]->pos(),QPointF(100,iY));
    iY-=15;
  }
  for(i=iD1o-1;i>=0;i--){
		m_item[i+iDec]->setVisible(true);
    m_item[i+iDec]->animatePosition(m_item[i+iDec]->pos(),QPointF(100,iY));
    iY-=15;
  }
	for (i=(iU1o+iU2o)/10-1;i>=0;i--){
		m_item[i+iD1o+iDec]->setVisible(true);
    m_item[i+iD1o+iDec]->animatePosition(m_item[i+iD1o+iDec]->pos(),QPointF(100,iY));
    iY-=15;
  }
  if(iU!=iR%10) {
    laGuida->setText(QString::fromUtf8("Conta le palline al centro e scrivi le unità"));
    laGuida->setVisible(true);
    laGuida->adjustSize();

  }else if ( iR>=10 && iU==(iR)%10 ){
    laGuida->setText(QString::fromUtf8("Scrivi il riporto"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
/*    for(i=0;i<iD2o;i++){
			m_item[i+iDec+10]->setVisible(true);
      m_item[i+iDec+10]->animatePosition(m_item[i+iDec+10]->pos(),QPointF(100,550-15*(iD2o-i-1)));
    }
*/    for(i=0;i<iD1o;i++){
			m_item[i+iDec]->setVisible(true);
      m_item[i+iDec]->animatePosition(m_item[i+iDec]->pos(),QPointF(-50,550-iD2o*15-15*(iD1o-i-1)));
    }
		for (i=0;i<(iU1o+iU2o)/10;i++){
 			m_item[i+iD1o+iDec]->setVisible(true);
      m_item[i+iD1o+iDec]->animatePosition(m_item[i+iD1o+iDec]->pos(),QPointF(-50,70-15*(i+iD1o+20+1)));
    }
    for(i=0;i<10-iD1o-(iU1o+iU2o)/10;i++){
			m_item[i+iDec+10]->setVisible(true);
      m_item[i+iDec+10]->animatePosition(m_item[i+iDec+10]->pos(),QPointF(-50,550-15*(iD2o-i-1)));
    }
		for (i=0;i<(iR)/10;i++){
 			m_item[i+iC1o+iCen]->setVisible(true);
      m_item[i+iC1o+iCen]->animatePosition(m_item[i+iC1o+iCen]->pos(),QPointF(50,70-15*(i+1)));
    }
    leRC->setVisible(true);
    leRC->setFocus();
  }else if(iU==(iR)%10 && iR<10){
    if(iC1+iC2+(int)(iR/10)==0){
		  laGuida->setText(QString::fromUtf8("Bene l'esercizio è finito"));
		  laGuida->setVisible(true);
		  laGuida->adjustSize();
    }else{  
		  laGuida->setText(QString::fromUtf8("Somma le centinaia"));
		  laGuida->setVisible(true);
		  laGuida->adjustSize();
		  leTC->setVisible(true);
		  leTC->setFocus();
		}
  }


}

void MainWindow::controlloCentinaia(const QString & text)
{
  int i, iU=text.toInt(),iR=(iC1o+iC2o+(iD1o+iD2o+(iU1o+iU2o)/10)/10);
  int iY=550;

  if (text.length()==0)return;

  for(i=iC2o-1;i>=0;i--){
		m_item[i+iCen+10]->setVisible(true);
    m_item[i+iCen+10]->animatePosition(m_item[i+iCen+10]->pos(),QPointF(50,iY));
    iY-=15;
  }
  for(i=iC1o-1;i>=0;i--){
		m_item[i+iCen]->setVisible(true);
    m_item[i+iCen]->animatePosition(m_item[i+iCen]->pos(),QPointF(50,iY));
    iY-=15;
  }
	for (i=(iD1o+iD2o+(iU1o+iU2o)/10)/10-1;i>=0;i--){
		m_item[i+iC1o+iCen]->setVisible(true);
    m_item[i+iC1o+iCen]->animatePosition(m_item[i+iC1o+iCen]->pos(),QPointF(50,iY));
    iY-=15;
  }

  if(iU!=iR%10) {
    laGuida->setText(QString::fromUtf8("Conta bene le palline della colonna di sinistra"));
    laGuida->setVisible(true);
    laGuida->adjustSize();

  }else{
    laGuida->setText(QString::fromUtf8("Bene l'esercizio è finito"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
  }

}

void MainWindow::controlloRiportoDecine(const QString & text)
{
  int iU=text.toInt();
  
  if(iU!=(iU1o+iU2o)/10){
    laGuida->setText(QString::fromUtf8("Conta le palline aggiunte in alto al centro"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
  }else{
    laGuida->setText(QString::fromUtf8("Somma le decine"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
    leTD->setVisible(true);
    leTD->setFocus();
  }

}

void MainWindow::controlloRiportoCentinaia(const QString & text)
{
  int  iU=text.toInt();
  
  if(iC1+iC2+(int)(iD1o+iD2o+(iU1o+iU2o)/10)/10==0){
		  laGuida->setText(QString::fromUtf8("Bene l'esercizio è finito"));
		  laGuida->setVisible(true);
		  laGuida->adjustSize();
  }else  if(iU!=(iD1o+iD2o+(iU1o+iU2o)/10)/10){
    laGuida->setText(QString::fromUtf8("Conta le palline aggiunte in alto a sinistra"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
  }else{
    laGuida->setText(QString::fromUtf8("Somma le centinaia"));
    laGuida->setVisible(true);
    laGuida->adjustSize();
    leTC->setVisible(true);
    leTC->setFocus();
  }
}

void MainWindow::vuotaGrafico()
{
  int i;
//  i_TempoAnim=500;

/*      for(i=0;i<10;i++){
        m_item[i+iUni]->animatePosition(m_item[i+iUni]->pos(),QPointF(-50,90+15*i));
      }
      for(i=0;i<10;i++){
        m_item[i+iDec]->animatePosition(m_item[i+iDec]->pos(),QPointF(-50,90+15*i));
      }
      for(i=0;i<10;i++){
        m_item[i+iCen]->animatePosition(m_item[i+iCen]->pos(),QPointF(-50,90+15*i));
      }
      for(i=0;i<10;i++){
        m_item[i+iUni+10]->animatePosition(m_item[i+iUni+10]->pos(),QPointF(-50,250+15*i));
      }
      for(i=0;i<10;i++){
        m_item[i+iDec+10]->animatePosition(m_item[i+iDec+10]->pos(),QPointF(-50,250+15*i));
      }
      for(i=0;i<10;i++){
        m_item[i+iCen+10]->animatePosition(m_item[i+iCen+10]->pos(),QPointF(-50,250+15*i));
      }
*/
      for(i=0;i<160;i++)m_item[i]->animatePosition(m_item[i]->pos(),QPointF(-50,15*i));
      iU1=iU2=iD1=iD2=iC1=iC2=iU1o=iU2o=iD1o=iD2o=iC1o=iC2o=0;
      laGuida->setText("");

}



